// --------------------------------------------------------
// Code generated by Papyrus C++
// --------------------------------------------------------

#ifndef PRODUCERCONSUMER_DATAEXCHANGE_PUBDATA_FIFO_FIFO_IMPL_H
#define PRODUCERCONSUMER_DATAEXCHANGE_PUBDATA_FIFO_FIFO_IMPL_H

/************************************************************
 FIFO_impl class header
 ************************************************************/

#include "ProducerConsumer/DataExchange_PubData/FIFO/Pkg_FIFO.h"

#include "AnsiCLibrary/Pkg_AnsiCLibrary.h"
#include "PrimitiveTypes/Pkg_PrimitiveTypes.h"
#include "ProducerConsumer/DataExchange_PubData/PushPull.h"
#include "ProducerConsumer/DataExchange_PubData/derivedTypes/fifo/DataExchange/PullConsumer_T.h"
#include "ProducerConsumer/DataExchange_PubData/derivedTypes/fifo/DataExchange/Push_T.h"
#include "ProducerConsumer/derivedTypes/ProducerConsumer/components/interfaces/PullConsumer_PubData.h"
#include "ProducerConsumer/derivedTypes/ProducerConsumer/components/interfaces/Push_PubData.h"
#include "componentlib/ContainerServices/LifeCycle.h"
#include "sysinterfaces/ILifeCycle.h"

namespace ProducerConsumer {
namespace components {
namespace interfaces {
struct PubData;
}
}
}

namespace ProducerConsumer {
namespace DataExchange_PubData {
namespace FIFO {

/************************************************************/
/**
 * Configuration attribute: the size of the FIFO
 * 
 */
class FIFO_impl: public ::sysinterfaces::ILifeCycle,
		public ::ProducerConsumer::DataExchange_PubData::derivedTypes::fifo::DataExchange::Push_T,
		public ::ProducerConsumer::DataExchange_PubData::derivedTypes::fifo::DataExchange::PullConsumer_T,
		public ::ProducerConsumer::derivedTypes::ProducerConsumer::components::interfaces::Push_PubData,
		public ::ProducerConsumer::derivedTypes::ProducerConsumer::components::interfaces::PullConsumer_PubData,
		public ::ProducerConsumer::DataExchange_PubData::PushPull,
		public ::componentlib::ContainerServices::LifeCycle {
public:

	/**
	 * 
	 */
	long m_size = 20;

	/**
	 * 
	 */
	long m_push_pos;

	/**
	 * 
	 */
	long m_pull_pos;

	/**
	 * 
	 */
	long m_filled;

	/**
	 * 
	 */
	::ProducerConsumer::components::interfaces::PubData *m_fifo;

	/**
	 * 
	 * @return ret 
	 */
	::ProducerConsumer::components::interfaces::PubData pull();

	/**
	 * 
	 * @param data 
	 */
	void push(::ProducerConsumer::components::interfaces::PubData /*in*/data);

	/**
	 * 
	 * @return ret 
	 */
	::PrimitiveTypes::Boolean hasData();

	/**
	 * 
	 */
	void activate();

	/**
	 * 
	 */
	void deactivate();

	/**
	 * 
	 */
	void configuration_complete();

	/**
	 * 
	 * @return ret 
	 */
	::ProducerConsumer::derivedTypes::ProducerConsumer::components::interfaces::Push_PubData* get_pushPPush_PubData();

	/**
	 * 
	 * @return ret 
	 */
	::ProducerConsumer::derivedTypes::ProducerConsumer::components::interfaces::PullConsumer_PubData* get_pullCPullConsumer_PubData();

	/**
	 * 
	 * @return ret 
	 */
	::sysinterfaces::ILifeCycle* get_lc();

};
/************************************************************/
/* External declarations (package visibility)               */
/************************************************************/

/* Inline functions                                         */

} // of namespace FIFO
} // of namespace DataExchange_PubData
} // of namespace ProducerConsumer

/************************************************************
 End of FIFO_impl class header
 ************************************************************/

#endif
